#include "bmp_headers.h"
#include <cstdint>
#include <iostream>
#include <string>
using namespace std;

const uint8_t bitmap_header::MAGIC_NUMBER[] = { 0x42, 0x4D };

ostream& operator<<(ostream &os, const windows_v3_header::CompressionMethod cm) {
   // dpendance pas gentille
   static const string NOMS[] = {
      "BI_RGB", "BI_RLE8", "BI_RLE4", "BI_BITFIELDS", "BI_JPEG", "BI_PNG"
   };
   return os << NOMS[cm];
}

ostream& operator<<(ostream &os, const windows_v3_header & hdr) {
   return os << "Largeur: " << hdr.width() << " px." << endl
             << "Hauteur: " << hdr.height () << " px." << endl
             << "Color panes: " << hdr.nb_color_panes() << endl
             << "Color depth: " << hdr.color_depth() << " bits" << endl
             << "Compression method: " << hdr.compression_method() << endl
             << "Raw bitmap size: " << hdr.raw_size() << endl
             << "Horizontal resolution: " << hdr.horizontal_resolution() << " px. per meter" << endl
             << "Vertical resolution: " << hdr.vertical_resolution() << " px. per meter" << endl
             << "Colors in palette: " << hdr.colors_in_palette() << endl
             << "Important colors: " << hdr.important_colors();
}


istream& operator>>(istream &is, bitmap &bmp) {
   if (is >> bmp.hdr && bmp.hdr.is_valid()) {
#ifdef _DEBUG
      cout << "Bitmap valide, taille " << bmp.hdr.size() << endl;
      cout << "Donnes dbutent  la position " << bmp.hdr.offset() << endl;
#endif
      if (is >> bmp.wv3hdr && bmp.wv3hdr.is_valid()) {
#ifdef _DEBUG
         cout << "Bitmap contient un Win v3 BMP header valide, taille " << bmp.wv3hdr.size() << endl;
         cout << bmp.wv3hdr << endl;
#endif
         is.seekg(static_cast<istream::off_type>(bmp.hdr.offset()), ios::beg);
         bmp.raw_data.clear();
         for (char val; is.get(val); bmp.raw_data.push_back(val))
            ;
      }
   }
   return is;
}
