#include "compresser_bitmap.h"
#include "bmp_headers.h"
#include "rgb_value.h"
#include "compresser_rle.h"
#include "minuter.h"
#include <fstream>
#include <chrono>
#include <iostream>
#include <string>
#include <vector>
using namespace std;
using namespace std::chrono;

void compresser_bitmap_rle(const string &nom) {
   ifstream ifs{ nom, ios::binary };
   if (bitmap bmp; ifs && ifs >> bmp) {
      vector<rgb_value> vrgb;
      {
         auto ecoule = tester([&]() {
            vrgb = to_rgb_values(begin(bmp.raw_data), end(bmp.raw_data));
            return 0;
         });
         cout << "Raw --> RGB, une image a la fois, " << bmp.raw_data.size() << " bytes" << endl;
      }
      vector<uint32_t> v_rle;
      /*
      //
      // pour fins de tests, une condition de poursuite simplifie
      //
      class condition_poursuite {
         enum { NIT = 20 };
         int nit {};
      public:
         condition_poursuite() = default;
         bool operator()() noexcept {
            if (++nit < NIT) return true;
            nit = 0;
            return false;
         }
      };
      */
      //
      // C'tait plus simple avant...
      //
//      vector<int32_t> v_rle = compresser_rle<int32_t>(vrgb);
#ifdef COMPTER_ITERATIONS
      int nit = 0;
#endif
      auto cur = begin(vrgb);
      for (auto now = system_clock::now();
           cur = compresser_rle<uint32_t>(cur, end(vrgb), back_inserter(v_rle), [now]() {
              return (system_clock::now() - now) < 500ms;
           }).first, cur != end(vrgb);
           now = system_clock::now())
      {
         // faire quelque chose
#ifdef COMPTER_ITERATIONS
         ++nit;
#endif
      }
#ifdef COMPTER_ITERATIONS
      cout << "Nombre d'itrations: " << nit << endl;
#endif
#ifdef _DEBUG
      auto nbytes = v_rle.size() * sizeof(uint32_t);
      cout << "Apres compression RLE: " << nbytes << " bytes" << endl;
#endif
   }
#ifdef _DEBUG
   else
      cerr << "Erreur de lecture, fichier " << nom << endl;
#endif
}

